<?php

namespace LT\AvatarOnRegistration\XF\Pub\Controller;

class Register extends XFCP_Register
{
    public function actionRegister()
    {
        $this->assertPostOnly();
        $this->assertRegistrationActive();

        $options = $this->options();

        $avatar = $this->request->getFile('avatar', false, false);
        if ($options->ltAor['enableUploading'] && $options->ltAor['requireUploading'] && !$avatar)
        {
            return $this->error(\XF::phrase('ltAor_please_upload_avatar'));
        }

        return parent::actionRegister();
    }

    protected function finalizeRegistration(\XF\Entity\User $user)
    {
        $options = $this->options();

        if ($options->ltAor['enableUploading'])
        {
            $avatar = $this->request->getFile('avatar', false, false);
            if ($avatar)
            {
                $avatarService = $this->service('XF:User\Avatar', $user);
                $avatarService->logIp(false);

                if (!$avatarService->setImageFromUpload($avatar))
                {
                    return $this->error($avatarService->getError());
                }

                if (!$avatarService->updateAvatar())
                {
                    return $this->error(\XF::phrase('new_avatar_could_not_be_processed'));
                }
            }
        }

        parent::finalizeRegistration($user);
    }
}