<?php

namespace LT\AvatarOnRegistration\XF\Service\User;

class Registration extends XFCP_Registration
{
    protected $avatar;

    public function setFromInput(array $input)
    {
        parent::setFromInput($input);

        $options = $this->app->options();

        if ($options->ltAor['enableUploading'])
        {
            $avatar = $this->app->request()->getFile('avatar', false, false);
            if ($options->ltAor['requireUploading'] && !$avatar)
            {
                return $this->user->error(\XF::phrase('ltAor_please_upload_avatar'));
            }
            if (!$avatar)
            {
                return;
            }
            
            $avatar->requireImage();
            if (!$avatar->isValid($errors))
            {
                $this->user->error(reset($errors));
                return false;
            }
        }
    }

    protected function _save()
    {
        $user = parent::_save();

        $this->setAvatar();

        return $user;
    }

    public function setAvatar()
    {
        if (!$this->user->user_id)
        {
            throw new \LogicException("User is not saved yet");
        }

        $options = $this->app->options();

        if ($options->ltAor['enableUploading'])
        {
            $avatar = $this->app->request()->getFile('avatar', false, false);
            if ($avatar)
            {
                $avatarService = $this->service('XF:User\Avatar', $this->user);
                $avatarService->logIp(false);

                if (!$avatarService->setImageFromUpload($avatar))
                {
                    return false;
                }

                return $avatarService->updateAvatar();
            }
        }
    }
}